Imports System.Threading

Public Class Form1
    Public Const div_y = 10
    Public Const div_x = 12
    Public Const box_delta_y = 40
    Public Const box_delta_x = 40
    Public Const c_RX_Count = 650
    Public Const RAM_size = 32768
    Public Const HeaderLength = 4 ' HeaderLength ist gleich 5 von 0 bis 4
    Public Const TL_off = 0 'TimeLines_off
    Public Const TL_1 = 1 'TimeLine_1
    Public Const TL_2 = 2 'TimeLine_2
    ' eine dritte Zeilinie => TL_3=3 definieren; Dim TimeLine(TL_3) und 
    ' DrawCursorLine(grafx.Graphics, TimeLine(TL_3), myPen7)
    Dim TimeLineData(TL_2) As Decimal 'Feld(0)0 - moving = False, sonst Zeiger auf Feldx (ZeitLinie1, ZeitLinie2...)
    Dim visbleTimeL As Boolean
    Dim Data(RAM_size + 1024) As Byte ' gre Index abgeleitet von SerialPort1.ReadBuffersize
    Delegate Sub SetTextCallback(ByVal x As Decimal)
    Dim Time_Bytes_Print As Integer
    Dim Time_div_set As Byte
    Dim DIV_loop As Decimal
    Dim DIV_teiler As Decimal
    Dim varDIV_loop As Decimal = 1
    Dim TP_DIV_loop As Decimal = 1
    Dim TrigPos As Boolean
    Dim trigoff As Byte
    Dim trigger_delay As Byte
    Dim trigger_prev As Boolean
    Dim trigger_vz As Integer = -1
    'Dim tr_delay_TL_korr As Decimal
    Dim sync_plus As Boolean
    Dim Switch_hold As Boolean
    Dim hold As Boolean
    Dim readDataHold As Boolean = False
    Dim TrPoint As Integer
    Dim TimeBase As Decimal
    Dim TimeDim As String
    Dim Uss_corr As Decimal = 22.8
    Dim UssGr_corr As Decimal = 1.175
    Dim Y0_line As Decimal = 146
    Dim delta_x1 As Decimal


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim ports() As String
        Dim port As String
        Dim count As Integer

        visbleTimeL = False
        TimeLineData(0) = TL_off
        TimeLineData(TL_1) = HeaderLength + 1
        TimeLineData(TL_2) = HeaderLength + 1
        Time_Bytes_Print = 100
        Write_Spectrum()
        Timer1.Interval = ReadIniValue(My.Application.Info.DirectoryPath & "\MyScope.ini", "Scope", "Timer-Interval")
        Timer1.Start()
        'Com Ports suchen und in Liste eintragen
        ports = System.IO.Ports.SerialPort.GetPortNames
        ComboBox_ComPort.Text = ports(0)
        For Each port In ports
            ComboBox_ComPort.Items.Add(port)
        Next port

        For count = 0 To c_RX_Count
            Data(count) = Y0_line
        Next
        ComboBox_ComPort.Text = ReadIniValue(My.Application.Info.DirectoryPath & "\MyScope.ini", "Default", "Port")
        Time_div_set = ReadIniValue(My.Application.Info.DirectoryPath & "\MyScope.ini", "Scope", "Time-div")
        If (Time_div_set < 0) And (Time_div_set > 14) Then
            Time_div_set = 12       ' Zeitbasis auf 1 ms
            TextBox_Horizomtal.Text = "1 ms"
        Else
            TextBox_Horizomtal.Text = ReadIniValue(My.Application.Info.DirectoryPath & "\MyScope.ini", "Scope", "Time-Text")
        End If
        TrackBar_Trigger.Value = ReadIniValue(My.Application.Info.DirectoryPath & "\MyScope.ini", "Scope", "Triggervalue")
        If (TrackBar_Trigger.Value < 0) And (TrackBar_Trigger.Value > 255) Then
            TrackBar_Trigger.Value = 170
        End If
        TrackBar_YPos.Value = ReadIniValue(My.Application.Info.DirectoryPath & "\MyScope.ini", "Scope", "Y-Position")
        If (TrackBar_YPos.Value < 0) And (TrackBar_YPos.Value > 255) Then
            TrackBar_YPos.Value = 128
        End If
        Uss_corr = ReadIniValue(My.Application.Info.DirectoryPath & "\MyScope.ini", "Measurement-correction", "Uss-corr")
        If (Uss_corr = 0) Or (Uss_corr > 1000) Then
            TextBox_Uss.Visible = False
            Uss_corr = 1
        End If
        UssGr_corr = ReadIniValue(My.Application.Info.DirectoryPath & "\MyScope.ini", "Measurement-correction", "UssGraph-corr")
        Y0_line = ReadIniValue(My.Application.Info.DirectoryPath & "\MyScope.ini", "Measurement-correction", "Y0-Line")
        SerialPort1.PortName() = ComboBox_ComPort.Text
    End Sub

    Private Sub Button_ComPort_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_ComPort.Click
        'Button COM Port Open/Close
        If SerialPort1.IsOpen = False Then
            Try
                SerialPort1.Open()
            Catch
                MsgBox("Error open " + ComboBox_ComPort.Text)
                Exit Sub
            End Try
            Button_ComPort.Text = "CLOSE"
            Button_ComPort.BackColor = SystemColors.Control
            ComboBox_ComPort.Enabled = False
            Time_print()
            set_AC()                ' AC
            set_triggeroff()
            set_trigfl()            ' positive Flanke
            TrackBar_Trigger_delay.Value = 0     ' keine Triggerverzgerung
            set_trigger_delay()
            sync_plus = True        ' wird gleich zurckgeschaltet, damit nicht mit sync_plus (gelb) anfngt
            set_trigger_del()       ' Schalter auf Triggerverzgerung
            sync_plus = False       ' sonst msste im ungnstigsten Fall Button 2 mal bettigt werden
            Switch_hold = True      ' wird durch set_hold auf False geschaltet - repitierend
            set_hold()
            set_y_pos()             ' Y-Position Offset
        Else
            Button_ComPort.Text = "OPEN"
            ComboBox_ComPort.Enabled = True
            Button_ComPort.BackColor = Color.Red
            SerialPort1.Close()
            Button_AC.BackColor = SystemColors.Control
            Button_DC.BackColor = SystemColors.Control
            Button_Tr_pos.BackColor = SystemColors.Control
            Button_Tr_neg.BackColor = SystemColors.Control
            Button_Tr_prev.BackColor = SystemColors.Control
            Button_Tr_prev.ForeColor = SystemColors.ControlText
            Button_Tr_delay.BackColor = SystemColors.Control
            Button_Tr_delay.ForeColor = SystemColors.ControlText
            Button_Hold.BackColor = SystemColors.Control
            GroupBox_TriggerDelay.ForeColor = SystemColors.ControlText
        End If
    End Sub

    Private Sub Write_Spectrum()

        Dim U_low As Decimal = 256
        Dim U_high As Decimal = 0
        Dim Uss As Decimal
        Dim i As Decimal
        Dim myGrafik As Graphics
        Dim myPen1 As New Pen(Color.Black, 2)
        Dim myPen2 As New Pen(Color.DarkGray, 1)
        Dim myPen3 As New Pen(Color.DarkGray, 3)
        Dim myPen4 As New Pen(Color.DarkRed, 2)
        Dim myPen5 As New Pen(Color.DarkBlue, 2)
        Dim count As Decimal

        Dim pb_x As Decimal
        Dim pb_y As Decimal

        Dim delta_y As Decimal
        Dim delta_x As Decimal

        Dim delta_y1 As Decimal
        'Dim delta_x1 As Decimal

        Dim grafx As BufferedGraphics
        Dim context As BufferedGraphicsContext

        Dim trigger_marker As Byte = 1

        context = BufferedGraphicsManager.Current
        context.MaximumBuffer = New Size(PictureBox1.Width + 1, PictureBox1.Height + 1)
        grafx = context.Allocate(PictureBox1.CreateGraphics(), New Rectangle(0, 0, PictureBox1.Width, PictureBox1.Height))

        'clear buffer
        grafx.Graphics.FillRectangle(Brushes.ForestGreen, 0, 0, PictureBox1.Width, PictureBox1.Height)

        myGrafik = Graphics.FromHwnd(hwnd:=PictureBox1().Handle)

        If Time_Bytes_Print = 0 Then Time_Bytes_Print = 1 '512


        pb_x = PictureBox1.Width - (2 * box_delta_x)
        pb_y = PictureBox1.Height - (2 * box_delta_y)

        delta_y = pb_y / div_y
        delta_x = pb_x / div_x

        delta_y1 = pb_y / 255              'AD-Wandler max. Digitalwert
        delta_x1 = pb_x / Time_Bytes_Print 'RX_DATA

        'paint horizontal lines
        For count = 0 To div_y
            If count = 5 Then
                grafx.Graphics.DrawLine(myPen3, box_delta_x, (delta_y * count) + box_delta_y, pb_x + box_delta_x, (delta_y * count) + box_delta_y)
            Else
                grafx.Graphics.DrawLine(myPen2, box_delta_x, (delta_y * count) + box_delta_y, pb_x + box_delta_x, (delta_y * count) + box_delta_y)
            End If
        Next

        'paint vertical lines
        For count = 0 To div_x
            If count = 6 Then
                grafx.Graphics.DrawLine(myPen3, (delta_x * count) + box_delta_x, box_delta_y, (delta_x * count) + box_delta_x, pb_y + box_delta_y)
            Else
                grafx.Graphics.DrawLine(myPen2, (delta_x * count) + box_delta_x, box_delta_y, (delta_x * count) + box_delta_x, pb_y + box_delta_y)
            End If
        Next

        'paint data line
        For count = 1 To Time_Bytes_Print 'RX_DATA
            i = (count * (varDIV_loop)) - varDIV_loop + HeaderLength + HScrollBar1.Value
            grafx.Graphics.DrawLine(myPen1, ((count) * delta_x1) - delta_x1 + box_delta_x, (255 - Data(i)) * UssGr_corr * delta_y1 + box_delta_y, (count * delta_x1) + box_delta_x, (255 - Data(i + varDIV_loop)) * UssGr_corr * delta_y1 + box_delta_y)
            If (U_high < Data(i)) Then
                U_high = Data(i)
            ElseIf (U_low > Data(i)) Then
                U_low = Data(i)
            End If
        Next

        DrawTriggerPoint(grafx.Graphics, pb_x, delta_y1)

        If visbleTimeL Then 'Cursor-Linien zeichnen
            DrawCursorLine(grafx.Graphics, TimeLineData(TL_2), pb_x, myPen4)
            DrawCursorLine(grafx.Graphics, TimeLineData(TL_1), pb_x, myPen5)
        End If

        'display buffer
        grafx.Render(myGrafik)
        Uss = (U_high - U_low) / Uss_corr
        TextBox_Uss.Text = "Uss " + Format(Uss, "0.0 V")
    End Sub

    Private Sub DrawTriggerPoint(ByVal graph As Graphics, ByVal pb_x As Decimal, ByVal delta_y As Decimal)
        Dim myPenTPoint As New Pen(Color.DarkRed, 3)
        Dim myPenTDreieck As New Pen(Color.DarkRed, 2)
        Dim TriggerPoint As Decimal = (TrPoint - HScrollBar1.Value) * delta_x1 / TP_DIV_loop
        If (TriggerPoint > 0) Then
            If (TriggerPoint <= pb_x) Then
                graph.DrawEllipse(myPenTPoint, TriggerPoint + box_delta_x - delta_x1, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y, 2, 2)
            Else
                'wenn Cursorlinien mit z.B. Scrollbar auerhalb des sichtbaren, so wenigsten Vierecke zum Zurckholen darstellen 
                graph.DrawLine(myPenTDreieck, pb_x + box_delta_x + 1, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y, pb_x + box_delta_x - 5, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y + 4)
                graph.DrawLine(myPenTDreieck, pb_x + box_delta_x + 1, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y, pb_x + box_delta_x - 5, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y - 4)
                graph.DrawLine(myPenTDreieck, pb_x + box_delta_x - 4, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y + 4, pb_x + box_delta_x - 4, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y - 4)
            End If
        Else
            graph.DrawLine(myPenTDreieck, box_delta_x - 2, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y, box_delta_x + 4, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y + 4)
            graph.DrawLine(myPenTDreieck, box_delta_x - 2, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y, box_delta_x + 4, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y - 4)
            graph.DrawLine(myPenTDreieck, box_delta_x + 4, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y + 4, box_delta_x + 4, (255 - trigoff) * UssGr_corr * delta_y + box_delta_y - 4)
        End If
    End Sub

    Private Sub DrawCursorLine(ByVal graph As Graphics, ByVal TimeLineIndex As Long, ByVal pb_x As Decimal, ByVal myPen As Pen)
        'trigger_delay * trigger_vz
        Dim TimeLine As Decimal = (TimeLineIndex - HScrollBar1.Value - HeaderLength) * delta_x1 / varDIV_loop
        If (TimeLine >= 0) Then
            If (TimeLine <= pb_x + delta_x1) Then
                Dim startVert As New Point(TimeLine + box_delta_x, box_delta_y)
                Dim endVert As New Point(TimeLine + box_delta_x, Me.PictureBox1.Height - box_delta_y + 2)
                graph.DrawRectangle(myPen, TimeLine - 3 + box_delta_x, box_delta_y - 5, 5, 5)
                graph.DrawLine(myPen, startVert, endVert)
            Else
                'wenn Cursorlinien mit z.B. Scrollbar auerhalb des sichtbaren, so wenigsten Vierecke zum Zurckholen darstellen 
                graph.DrawRectangle(myPen, pb_x + box_delta_x - 3, box_delta_y - 5, 5, 5)
            End If
        Else
            graph.DrawRectangle(myPen, box_delta_x - 3, box_delta_y - 5, 5, 5)
        End If
    End Sub

    Private Sub PictureBox1_MouseDoubleClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDoubleClick
        If visbleTimeL And e.Button = Windows.Forms.MouseButtons.Left Then
            If e.Y >= box_delta_y - 6 And e.Y <= box_delta_y + 1 Then 'Innerhalb der oberen und unteren Line des Vierecks?
                Dim tmpTimeLineData1 As Decimal = (TimeLineData(TL_1) - HScrollBar1.Value - HeaderLength) * delta_x1 / varDIV_loop
                Dim tmpTimeLineData2 As Decimal = (TimeLineData(TL_2) - HScrollBar1.Value - HeaderLength) * delta_x1 / varDIV_loop
                If e.X - 4 <= box_delta_x And e.X + 3 >= box_delta_x Then 'linkes Viereck
                    If tmpTimeLineData1 < 0 Then
                        TimeLineData(TL_1) = HScrollBar1.Value + HeaderLength
                    ElseIf tmpTimeLineData2 < 0 Then
                        TimeLineData(TL_2) = HScrollBar1.Value + HeaderLength
                    End If
                    'rechtes Viereck
                ElseIf e.X - 4 <= PictureBox1.Width - box_delta_x And e.X + 3 >= PictureBox1.Width - box_delta_x Then
                    If tmpTimeLineData1 > PictureBox1.Width - (2 * box_delta_x) Then
                        TimeLineData(TL_1) = (PictureBox1.Width - (2 * box_delta_x)) * varDIV_loop / delta_x1 + HScrollBar1.Value + HeaderLength
                    ElseIf tmpTimeLineData2 > PictureBox1.Width - (2 * box_delta_x) Then
                        TimeLineData(TL_2) = (PictureBox1.Width - (2 * box_delta_x)) * varDIV_loop / delta_x1 + HScrollBar1.Value + HeaderLength
                    End If
                End If
            End If
        End If
    End Sub

    Private Sub PictureBox1_MouseMove(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseMove
        If TimeLineData(0) > TL_off Then
            If e.X < box_delta_x Then                         'linker Rand erreicht?
                TimeLineData(TimeLineData(0)) = HScrollBar1.Value + HeaderLength
            ElseIf e.X > PictureBox1.Width - box_delta_x Then 'rechter Rand erreicht?
                TimeLineData(TimeLineData(0)) = (PictureBox1.Width - (2 * box_delta_x)) * varDIV_loop / delta_x1 + HScrollBar1.Value + HeaderLength
            Else                                              'innerhalb des Bereiches
                TimeLineData(TimeLineData(0)) = ((e.X - box_delta_x) * varDIV_loop / delta_x1) + HScrollBar1.Value + HeaderLength
            End If
        End If
        CalculateTime()
        If Switch_hold Then
            Write_Spectrum()
        End If
    End Sub

    Private Sub PictureBox1_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDown
        If visbleTimeL And e.Button = Windows.Forms.MouseButtons.Left Then
            If e.Y >= box_delta_y - 6 And e.Y <= Me.PictureBox1.Height - box_delta_y + 2 Then 'Innerhalb der oberen und unteren Line?
                Dim tmpTimeLineData1 As Decimal = (TimeLineData(TL_1) - HScrollBar1.Value - HeaderLength) * delta_x1 / varDIV_loop + box_delta_x
                Dim tmpTimeLineData2 As Decimal = (TimeLineData(TL_2) - HScrollBar1.Value - HeaderLength) * delta_x1 / varDIV_loop + box_delta_x
                If e.X - 3 <= tmpTimeLineData1 And e.X + 2 >= tmpTimeLineData1 Then
                    TimeLineData(0) = TL_1
                ElseIf e.X - 3 <= tmpTimeLineData2 And e.X + 2 >= tmpTimeLineData2 Then
                    TimeLineData(0) = TL_2
                End If
            End If
        End If
    End Sub

    Private Sub PictureBox1_MouseUp(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseUp
        If e.Button = Windows.Forms.MouseButtons.Left Then
            TimeLineData(0) = TL_off
        End If
    End Sub

    Private Sub Button_Cursor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Cursor.Click
        If visbleTimeL Then
            visbleTimeL = False
            Button_Cursor.Text = "on"
            TextBox_Cu_Zeit.Text = ""
            TextBox_Cu_Frequenz.Text = ""
        Else
            visbleTimeL = True
            Button_Cursor.Text = "off"
            CalculateTime()
        End If
        If Switch_hold Then
            Write_Spectrum()
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If Not (hold) Then ' Timer strt zwar nicht, muss aber nicht sein
            If SerialPort1.IsOpen = True Then
                Try
                    SerialPort1.Write("GET")
                    SerialPort1.Write(Chr(13))
                Catch
                End Try
            End If
        End If
        Write_Spectrum()
    End Sub

    Private Sub SerialPort1_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        Dim SaveThreadProgressBar As Thread = Nothing
        Dim Byte_RX_Count As Decimal
        Dim p As Byte
        Dim tmp_p As Byte = 0
        If Not (SerialPort1.BytesToRead = 0) Then
            If Not (hold) Then
                For Byte_RX_Count = 0 To (c_RX_Count + HeaderLength)
                    Try
                        While SerialPort1.BytesToRead = 0
                        End While
                        Data(Byte_RX_Count) = SerialPort1.ReadByte()
                    Catch
                    End Try
                Next
                TrPoint = Data(4) ' BitSchieben von Array-Inhalten nicht mglich
                TrPoint = Data(3) + (TrPoint << 8) ' Triggerpunkt besteht aus msb und lsb
                If Switch_hold Then
                    If (Data(1) = 255) And (Data(2) = 0) Then
                        hold = True
                        Button_Hold.BackColor = Color.Yellow
                        readDataHold = True
                        TrPoint = TrPoint + 2 ' 2 - rs232-bertragung erst kurz nach Triggerung
                        'TrPoint = Data(4) ' BitSchieben von Array-Inhalten nicht mglich
                        'TrPoint = Data(3) + (TrPoint << 8) + 2 ' Triggerpunkt besteht aus msb und lsb
                        '                                        2 - rs232-bertragung erst kurz nach Triggerung
                        GroupBox_TriggerDelayVisible(0)
                        GroupBox_Y_PosVisible(0)
                    End If
                Else
                    If Not ((Data(1) = 0) And (Data(2) = 255)) Then
                        Try
                            SerialPort1.DiscardInBuffer()
                        Catch
                        End Try
                    End If
                End If
            Else
                If readDataHold Then ' macht das Einlesen HoldRam noch etwas sicherer
                    ProgressVisible(1)
                    For Byte_RX_Count = 0 To RAM_size - 5 ' rs232-bertragung relativ unsicher
                        Try
                            While SerialPort1.BytesToRead = 0
                            End While
                            Data(Byte_RX_Count) = SerialPort1.ReadByte()
                        Catch
                        End Try
                        p = Byte_RX_Count * 100 \ (RAM_size + 1) ' sonst bremst ProgressBar
                        If p > tmp_p Then                        ' das Einlesen zu sehr aus
                            tmp_p = p                            ' so um ca. Faktor 2
                            set_Progress(p)                      ' schneller
                        End If
                    Next
                    Try
                        SerialPort1.DiscardInBuffer() 'da Lesepuffer nicht vollstdig ausgelesen wird
                    Catch
                    End Try
                    ProgressVisible(0)
                    If Not (trigger_prev) Then
                        TrPoint = TrPoint + (DIV_loop + 1) * trigger_delay
                    End If
                    HScrollBarValue(TrPoint)                 ' im TriggerEreignis mit Darstellung beginnen 
                    HScrollBarVisible(1)
                    TimeLineData(TL_1) = TrPoint + HeaderLength
                    TimeLineData(TL_2) = TrPoint + HeaderLength
                    TrPoint = TrPoint + (DIV_loop + 1) * trigger_delay * trigger_vz
                    readDataHold = False
                    If DIV_loop > 0 Then
                        GroupBox_DehnenVisible(1)
                        TrackBar_DehnenMax(DIV_loop + 1)
                        TrackBar_DehnenValue(DIV_loop + 1)
                        varDIV_loop = DIV_loop + 1
                        TP_DIV_loop = DIV_loop + 1
                    End If
                Else
                    Try
                        SerialPort1.DiscardInBuffer() 'da Lesepuffer nicht vollstdig ausgelesen wird
                    Catch
                    End Try
                End If
            End If
        End If
    End Sub
    Private Sub set_Progress(ByVal x As Decimal)
        If Me.ProgressBar1.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf set_Progress)
            Me.Invoke(d, New Object() {x})
        Else
            Me.ProgressBar1.Value = x
        End If
    End Sub
    Private Sub ProgressVisible(ByVal x As Decimal)
        If Me.ProgressBar1.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf ProgressVisible)
            Me.Invoke(d, New Object() {x})
        Else
            Me.ProgressBar1.Visible = x
        End If
    End Sub
    Private Sub HScrollBarValue(ByVal x As Decimal)
        If Me.HScrollBar1.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf HScrollBarValue)
            Me.Invoke(d, New Object() {x})
        Else
            Me.HScrollBar1.Value = x
        End If
    End Sub
    Private Sub HScrollBarVisible(ByVal x As Decimal)
        If Me.HScrollBar1.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf HScrollBarVisible)
            Me.Invoke(d, New Object() {x})
        Else
            Me.HScrollBar1.Visible = x
        End If
    End Sub
    Private Sub GroupBox_Y_PosVisible(ByVal x As Decimal)
        If Me.GroupBox_Y_Pos.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf GroupBox_Y_PosVisible)
            Me.Invoke(d, New Object() {x})
        Else
            Me.GroupBox_Y_Pos.Visible = x
        End If
    End Sub
    Private Sub GroupBox_TriggerDelayVisible(ByVal x As Decimal)
        If Me.GroupBox_TriggerDelay.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf GroupBox_TriggerDelayVisible)
            Me.Invoke(d, New Object() {x})
        Else
            Me.GroupBox_TriggerDelay.Visible = x
        End If
    End Sub
    Private Sub GroupBox_DehnenVisible(ByVal x As Decimal)
        If Me.GroupBox_Dehnen.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf GroupBox_DehnenVisible)
            Me.Invoke(d, New Object() {x})
        Else
            Me.GroupBox_Dehnen.Visible = x
        End If
    End Sub
    Private Sub TrackBar_DehnenMax(ByVal x As Decimal)
        If Me.TrackBar_Dehnen.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf TrackBar_DehnenMax)
            Me.Invoke(d, New Object() {x})
        Else
            Me.TrackBar_Dehnen.Maximum = x
        End If
    End Sub
    Private Sub TrackBar_DehnenValue(ByVal x As Decimal)
        If Me.TrackBar_Dehnen.InvokeRequired Then
            Dim d As New SetTextCallback(AddressOf TrackBar_DehnenValue)
            Me.Invoke(d, New Object() {x})
        Else
            Me.TrackBar_Dehnen.Value = x
        End If
    End Sub

    Private Sub Button_t_plus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_t_plus.Click
        If (SerialPort1.IsOpen = True) And Not (hold) Then
            If Time_div_set < 15 Then
                Time_div_set = Time_div_set + 1
            End If
            Time_print()
        End If
    End Sub

    Private Sub Button_t_minus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_t_minus.Click
        If (SerialPort1.IsOpen = True) And Not (hold) Then
            If Time_div_set > 0 Then
                Time_div_set = Time_div_set - 1
            End If
            Time_print()
        End If
    End Sub

    Private Sub Time_print()
        'bei Teiler 1 max RAM-Inhalt 20ns * 1 * 32768 = 655369 ns ca. 655 s
        'innerhalb ca. des halben Speichers wird Triggerflanke ermittelt, so
        'dass im ungnstigen Fall nur die halbe Aufzeichnungszeit fr das Signal
        'zur Verfgung steht. Die Triggerverzgerung beeinflusst diese zustzlich.
        Dim DIV As String
        If (Time_div_set = 0) Then
            ' 100 ns
            Time_Bytes_Print = 60
            DIV_loop = 0
            DIV_teiler = 0
            '1 * 20ns * 60 Sampels /12Div = 100ns ** H
            TimeBase = 100
            TimeDim = " ns"
        End If

        If (Time_div_set = 1) Then
            ' 250 ns
            Time_Bytes_Print = 150
            DIV_loop = 0
            DIV_teiler = 0
            '1 * 20ns * 150 Sampels /12Div = 250ns ** H
            TimeBase = 250
            TimeDim = " ns"
        End If

        If (Time_div_set = 2) Then
            ' 500 ns
            Time_Bytes_Print = 300
            DIV_loop = 0
            DIV_teiler = 0
            '1 * 20ns * 300 Sampels / 12Div = 500ns ** H
            TimeBase = 500
            TimeDim = " ns"
        End If
        If (Time_div_set = 3) Then
            ' 1 s
            Time_Bytes_Print = 600
            DIV_loop = 0
            DIV_teiler = 0
            '1 * 20ns * 600Sampels / 12 Div = 1000ns 1s ** H
            TimeBase = 1
            TimeDim = " s"
        End If
        If (Time_div_set = 4) Then
            ' 2.5 s
            Time_Bytes_Print = 500
            DIV_loop = 2
            DIV_teiler = 0
            '3 * 20ns * 500Sampels / 12 Div = 2500ns 2,5s ** H
            TimeBase = 2.5
            TimeDim = " s"
        End If

        If (Time_div_set = 5) Then
            '5 s
            Time_Bytes_Print = 600
            DIV_loop = 4
            DIV_teiler = 0
            '5 * 20ns * 600Sampels / 12 Div = 5000ns 5s ** H
            TimeBase = 5
            TimeDim = " s"
        End If

        If (Time_div_set = 6) Then
            ' 10 s
            Time_Bytes_Print = 600
            DIV_loop = 9
            DIV_teiler = 0
            '10 * 20ns * 600 Sampels / 12Div = 10000 ns 10 s ** H
            TimeBase = 10
            TimeDim = " s"
        End If

        'bei Teiler 2 max RAM-Inhalt 20ns * 2 * 32768 = 1310720 ns ca. 1,3 ms
        If (Time_div_set = 7) Then
            ' 25 s
            Time_Bytes_Print = 625
            DIV_loop = 11
            DIV_teiler = 3
            '12 * 2 * 20ns * 625 Sampels /12Div = 25000 ns 25 s ** H
            TimeBase = 25
            TimeDim = " s"
        End If

        'bei Teiler 32 max RAM-Inhalt 20ns * 32 * 32768 = 20971520 ns ca. 21 ms
        If (Time_div_set = 8) Then
            ' 50 s
            Time_Bytes_Print = 469
            DIV_loop = 1
            DIV_teiler = 1
            '2 * 32 * 20ns * 469 Sampels /12Div = 50027 ns ca 50 s ** H
            TimeBase = 50
            TimeDim = " s"
        End If

        If (Time_div_set = 9) Then
            ' 100 s
            Time_Bytes_Print = 625
            DIV_loop = 2
            DIV_teiler = 1
            '3 * 32 * 20ns * 625 Sampels /12Div = 100000ns 100s ** H
            TimeBase = 100
            TimeDim = " s"
        End If

        If (Time_div_set = 10) Then
            ' 250 s
            Time_Bytes_Print = 521
            DIV_loop = 8
            DIV_teiler = 1
            '9 * 32 * 20ns * 521 Sampels /12Div = 250080ns ca 250s ** H
            TimeBase = 250
            TimeDim = " s"
        End If

        If (Time_div_set = 11) Then
            ' 500 s
            Time_Bytes_Print = 625
            DIV_loop = 14
            DIV_teiler = 1
            '15 * 32 * 20ns * 625Sampels /12Div = 500000ns 500s ** H
            TimeBase = 500
            TimeDim = " s"
        End If

        'bei Teiler 256 max RAM-Inhalt 20ns * 256 * 32768 = 167772160 ns ca. 167 ms
        If (Time_div_set = 12) Then
            ' 1 ms
            Time_Bytes_Print = 469
            DIV_loop = 4
            DIV_teiler = 2
            '5 * 256 * 20ns * 469Sampels /12Div = 1000533ns ca 1ms
            TimeBase = 1
            TimeDim = " ms"
        End If

        If (Time_div_set = 13) Then
            ' 2.5 ms
            Time_Bytes_Print = 586
            DIV_loop = 9
            DIV_teiler = 2
            '10 * 256 * 20ns * 586Sampels /12Div = 2500267ns ca 2.5ms
            TimeBase = 2.5
            TimeDim = " ms"
        End If

        If (Time_div_set = 14) Then
            ' 5 ms
            Time_Bytes_Print = 558
            DIV_loop = 20
            DIV_teiler = 2
            '21 * 256 * 20ns * 558Sampels /12Div = 4999680ns ca 5ms
            TimeBase = 5
            TimeDim = " ms"
        End If

        If (Time_div_set = 15) Then
            ' 10 ms
            Time_Bytes_Print = 601
            DIV_loop = 38
            DIV_teiler = 2
            '39 * 256 * 20ns * 601 Sampels /12Div = 10000640ns ca 10ms
            TimeBase = 10
            TimeDim = " ms"
        End If

        DIV = "DIV " + CStr(DIV_teiler) + "," + CStr(DIV_loop)
        Try
            SerialPort1.Write(DIV)
            SerialPort1.Write(Chr(13))
        Catch
        End Try
        TP_DIV_loop = DIV_loop + 1
        TextBox_Horizomtal.Text = CStr(TimeBase) + TimeDim
        CalculateTime()
    End Sub

    Private Sub Button_set_AC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_AC.Click
        If Not (hold) Then
            set_AC()
        End If
    End Sub
    Private Sub set_AC()
        If SerialPort1.IsOpen = True Then
            Button_AC.BackColor = Color.LightGreen()
            Button_DC.BackColor = SystemColors.Control
            Try
                SerialPort1.Write("AC")
                SerialPort1.Write(Chr(13))
            Catch
            End Try
        End If
    End Sub

    Private Sub Button_set_DC_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_DC.Click
        If Not (hold) Then
            set_DC()
        End If
    End Sub
    Private Sub set_DC()
        If SerialPort1.IsOpen = True Then
            Button_DC.BackColor = Color.LightGreen()
            Button_AC.BackColor = SystemColors.Control
            Try
                SerialPort1.Write("DC")
                SerialPort1.Write(Chr(13))
            Catch
            End Try
        End If
    End Sub

    Private Sub TrackBar_YPos_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar_YPos.Scroll
        set_y_pos()
    End Sub
    Private Sub set_y_pos()
        Dim offset As Byte
        If SerialPort1.IsOpen = True Then
            offset = TrackBar_YPos.Value
            Try
                SerialPort1.Write("OFFSET")
                SerialPort1.Write(Str(offset))
                SerialPort1.Write(Chr(13))
            Catch
            End Try
        End If
    End Sub

    Private Sub ComboBox_ComPort_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox_ComPort.SelectedIndexChanged
        SerialPort1.PortName() = ComboBox_ComPort.Text
    End Sub

    Private Sub Button_Pr_print_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Pr_print.Click
        If PrintDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            PrintDocument1.Print()
        End If
    End Sub

    Private Sub Button_Pr_prev_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Pr_prev.Click
        PrintPreviewDialog1.Document = PrintDocument1
        If PrintPreviewDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
            PrintDocument1.Print()
        End If
    End Sub

    Private Sub PrintDocument1_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage
        Dim i As Decimal
        Dim grafx As Graphics = e.Graphics
        Dim myPen1 As New Pen(Color.Black, 1)
        Dim myPen2 As New Pen(Color.DarkGray, 1)
        Dim myPen3 As New Pen(Color.DarkGray, 3)
        Dim count As Integer

        Dim pb_x As Integer
        Dim pb_y As Integer

        Dim delta_y As Decimal
        Dim delta_x As Decimal

        Dim delta_y1 As Decimal
        Dim delta_x1 As Decimal

        If Time_Bytes_Print > c_RX_Count Then Time_Bytes_Print = c_RX_Count
        If Time_Bytes_Print = 0 Then Time_Bytes_Print = c_RX_Count

        pb_x = 650 - (2 * box_delta_x)
        pb_y = 520 - (2 * box_delta_y)

        delta_y = pb_y / div_y
        delta_x = pb_x / div_x

        delta_y1 = pb_y / 255
        delta_x1 = pb_x / Time_Bytes_Print 'RX_DATA
        'paint horizontal lines
        For count = 0 To div_y
            If count = 5 Then
                grafx.DrawLine(myPen3, box_delta_x, (delta_y * count) + box_delta_y, pb_x + box_delta_x, (delta_y * count) + box_delta_y)
            Else
                grafx.DrawLine(myPen2, box_delta_x, (delta_y * count) + box_delta_y, pb_x + box_delta_x, (delta_y * count) + box_delta_y)
            End If
        Next

        'paint vertical lines
        For count = 0 To div_x
            If count = 6 Then
                grafx.DrawLine(myPen3, (delta_x * count) + box_delta_x, box_delta_y, (delta_x * count) + box_delta_x, pb_y + box_delta_y)
            Else
                grafx.DrawLine(myPen2, (delta_x * count) + box_delta_x, box_delta_y, (delta_x * count) + box_delta_x, pb_y + box_delta_y)
            End If
        Next

        'paint data line
        For count = 1 To Time_Bytes_Print 'RX_DATA
            i = (count * (varDIV_loop)) - (varDIV_loop) + HeaderLength + HScrollBar1.Value
            grafx.DrawLine(myPen1, ((count) * delta_x1) - delta_x1 + box_delta_x, (255 - Data(i)) * UssGr_corr * delta_y1 + box_delta_y, (count * delta_x1) + box_delta_x, (255 - Data(i + varDIV_loop)) * UssGr_corr * delta_y1 + box_delta_y)
        Next
    End Sub

    Private Sub TrackBar_Trigger_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar_Trigger.Scroll
        If hold Then
            TrackBar_Trigger.Value = trigoff
        End If
        set_triggeroff()
    End Sub
    Private Sub set_triggeroff()
        If SerialPort1.IsOpen = True Then
            trigoff = TrackBar_Trigger.Value
            Try
                SerialPort1.Write("TRIGOFF")
                SerialPort1.Write(Str(trigoff))
                SerialPort1.Write(Chr(13))
            Catch
            End Try
        End If
    End Sub

    Private Sub Button_Tr_pos_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Tr_pos.Click
        If Not (hold) Then
            set_trigfl()
        End If
    End Sub
    Private Sub set_trigfl()
        If SerialPort1.IsOpen = True Then
            Button_Tr_pos.BackColor = Color.LightGreen()
            Button_Tr_neg.BackColor = SystemColors.Control
            TrigPos = True
            Try
                SerialPort1.Write("TRIGFH")
                SerialPort1.Write(Chr(13))
            Catch
            End Try
        End If
    End Sub

    Private Sub Button_Tr_neg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Tr_neg.Click
        If Not (hold) Then
            set_trigfh()
        End If
    End Sub
    Private Sub set_trigfh()
        If SerialPort1.IsOpen = True Then
            Button_Tr_neg.BackColor = Color.LightGreen()
            Button_Tr_pos.BackColor = SystemColors.Control
            TrigPos = False
            Try
                SerialPort1.Write("TRIGFL")
                SerialPort1.Write(Chr(13))
            Catch
            End Try
        End If
    End Sub

    Private Sub CalculateTime()
        Dim pTime As Decimal
        Dim Result As Decimal
        Dim tmpTime As Decimal
        Dim DimResult As String = ""
        If visbleTimeL Then
            pTime = TimeLineData(TL_1) - TimeLineData(TL_2) + 0.000005
            If pTime < 0 Then
                pTime = pTime * -1
            End If
            If hold Then
                tmpTime = pTime * 20                    ' DIV_loop + 1 ist hier in VB2008 Software 
            Else
                tmpTime = pTime * (DIV_loop + 1) * 20   ' DIV_loop + 1 hineinsrechnen, da in Firmware
            End If
            Result = CalculateTimeDim(tmpTime, DIV_teiler, DimResult)
            TextBox_Cu_Zeit.Text = FormatTimeDim(Result, DimResult)
            DimResult = "Hz" ' zur Steuerung von CalculateTimeDim - so Ausgabe der Frequenz alles andere Zeitausgabe
            Result = CalculateTimeDim(tmpTime, DIV_teiler, DimResult)
            TextBox_Cu_Frequenz.Text = FormatTimeDim(Result, DimResult)
        End If
    End Sub

    Private Sub TrackBar_Trigger_delay_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar_Trigger_delay.Scroll
        set_trigger_delay()
    End Sub
    Private Sub set_trigger_delay()
        If SerialPort1.IsOpen = True Then
            TimeLineData(TL_1) = TimeLineData(TL_1) + (TrackBar_Trigger_delay.Value - trigger_delay) * trigger_vz
            TimeLineData(TL_2) = TimeLineData(TL_2) + (TrackBar_Trigger_delay.Value - trigger_delay) * trigger_vz
            trigger_delay = TrackBar_Trigger_delay.Value
            Try
                SerialPort1.Write("TRIGDEL")
                SerialPort1.Write(Str(trigger_delay))
                SerialPort1.Write(Chr(13))
            Catch
            End Try
            If (trigger_delay > 0) Then
                GroupBox_TriggerDelay.ForeColor = Color.Red
            Else
                GroupBox_TriggerDelay.ForeColor = SystemColors.ControlText
            End If
        End If
    End Sub

    Private Sub Button_Tr_prev_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Tr_prev.Click
        set_trigger_prev()
    End Sub
    Private Sub set_trigger_prev()
        If SerialPort1.IsOpen = True Then
            If trigger_prev Then
                If sync_plus Then
                    sync_plus = False
                    Button_Tr_prev.ForeColor = SystemColors.ControlText
                    Try
                        SerialPort1.Write("NSYNCP")
                        SerialPort1.Write(Chr(13))
                    Catch
                    End Try
                Else
                    sync_plus = True 'nur bei Synchronisation Datenbertragung
                    Button_Tr_prev.ForeColor = Color.Yellow
                    Try
                        SerialPort1.Write("SYNCP")
                        SerialPort1.Write(Chr(13))
                    Catch
                    End Try
                End If
            Else
                sync_plus = False
                Button_Tr_prev.ForeColor = SystemColors.ControlText
                Button_Tr_delay.ForeColor = SystemColors.ControlText
                Try
                    SerialPort1.Write("NSYNCP")
                    SerialPort1.Write(Chr(13))
                Catch
                End Try
                trigger_prev = True
                trigger_vz = 1
            End If
            Button_Tr_prev.BackColor = Color.LightGreen()
            Button_Tr_delay.BackColor = SystemColors.Control
            Try
                SerialPort1.Write("TRPREV")
                SerialPort1.Write(Chr(13))
            Catch
            End Try
        End If
    End Sub

    Private Sub Button_Tr_delay_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Tr_delay.Click
        set_trigger_del()
    End Sub
    Private Sub set_trigger_del()
        If SerialPort1.IsOpen = True Then
            If Not (trigger_prev) Then
                If sync_plus Then
                    sync_plus = False
                    Button_Tr_delay.ForeColor = SystemColors.ControlText
                    Try
                        SerialPort1.Write("NSYNCP")
                        SerialPort1.Write(Chr(13))
                    Catch
                    End Try
                Else
                    sync_plus = True 'nur bei Synchronisation Datenbertragung
                    Button_Tr_delay.ForeColor = Color.Yellow
                    Try
                        SerialPort1.Write("SYNCP")
                        SerialPort1.Write(Chr(13))
                    Catch
                    End Try
                End If
            Else
                sync_plus = False
                Button_Tr_delay.ForeColor = SystemColors.ControlText
                Button_Tr_prev.ForeColor = SystemColors.ControlText
                Try
                    SerialPort1.Write("NSYNCP")
                    SerialPort1.Write(Chr(13))
                Catch
                End Try
                trigger_prev = False
                trigger_vz = -1
            End If
            Button_Tr_delay.BackColor = Color.LightGreen()
            Button_Tr_prev.BackColor = SystemColors.Control
            Try
                SerialPort1.Write("TRDEL")
                SerialPort1.Write(Chr(13))
            Catch
            End Try
        End If
    End Sub

    Private Sub Button_Hold_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Hold.Click
        set_hold()
    End Sub
    Private Sub set_hold()
        If SerialPort1.IsOpen = True Then
            If Switch_hold Then
                Switch_hold = False
                hold = False
                varDIV_loop = 1        'so kann in Write_Spectrum() gleiches 'paint data line verwendet werden
                HScrollBar1.Value = 1  'so kann in Write_Spectrum() gleiches 'paint data line verwendet werden
                TP_DIV_loop = DIV_loop + 1
                Time_print()
                Button_Hold.BackColor = SystemColors.Control
                HScrollBar1.Visible = False
                GroupBox_Dehnen.Visible = False
                GroupBox_Dehnen.ForeColor = SystemColors.ControlText
                GroupBox_TriggerDelay.Visible = True
                GroupBox_Y_Pos.Visible = True
                TimeLineData(TL_1) = HeaderLength + 1
                TimeLineData(TL_2) = HeaderLength + 1
                If Not (sync_plus) Then
                    sync_plus = False 'nur bei Synchronisation Datenbertragung
                    Try
                        SerialPort1.Write("NSYNCP")
                        SerialPort1.Write(Chr(13))
                    Catch
                    End Try
                End If
                Try
                    SerialPort1.Write("NHOLD")
                    SerialPort1.Write(Chr(13))
                Catch
                End Try
                Button_Hold.BackColor = SystemColors.Control
            Else
                Switch_hold = True
                Button_Hold.BackColor = Color.LightGreen()
                HScrollBar1.Maximum = RAM_size - (((Time_Bytes_Print + 1) * (DIV_loop + 1)) - (DIV_loop + 1)) - 11 ' 10 besteht aus HeaderLength und 6 welche weniger gelesen werden
                Try
                    SerialPort1.Write("SYNCP") 'bei Hold immer sync_plus verwenden, aber nicht merken
                    SerialPort1.Write(Chr(13))
                    SerialPort1.Write("HOLD")
                    SerialPort1.Write(Chr(13))
                    SerialPort1.Write("HOLDRAM")
                    SerialPort1.Write(Chr(13))
                Catch
                End Try
            End If
        End If
    End Sub

    Private Sub HScrollBar1_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles HScrollBar1.Scroll
        Write_Spectrum()
    End Sub

    Private Sub TrackBar_Dehnen_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar_Dehnen.Scroll
        Dim DimResult As String = ""
        Dim Result As Decimal
        varDIV_loop = TrackBar_Dehnen.Value
        TP_DIV_loop = varDIV_loop
        HScrollBar1.Maximum = RAM_size - (((Time_Bytes_Print + 1) * (varDIV_loop)) - (varDIV_loop)) - 11
        If (varDIV_loop < DIV_loop + 1) Then
            GroupBox_Dehnen.ForeColor = Color.Red
        Else
            GroupBox_Dehnen.ForeColor = SystemColors.ControlText
        End If
        Result = CalculateTimeDim(varDIV_loop * 20 * Time_Bytes_Print / div_x, DIV_teiler, DimResult)
        TextBox_Horizomtal.Text = FormatTimeDim(Result, DimResult)
        CalculateTime()
        Write_Spectrum()
    End Sub

    Private Function CalculateTimeDim(ByVal Result As Decimal, ByVal v_teiler As Integer, ByRef DimResult As String) As Decimal
        Dim teiler As Integer
        Select Case v_teiler
            Case 0
                teiler = 1
            Case 1
                teiler = 32
            Case 2
                teiler = 256
            Case 3
                teiler = 2
        End Select
        Result = Result * teiler 'z.B.: TrackBar_Dehnen.Value * teiler * 20 * Time_Bytes_Print / 12
        If Not (DimResult = "Hz") Then
            If Result < 1000 Then
                DimResult = " ns"
            Else
                Result = Result / 1000
                If Result < 1000 Then
                    DimResult = " s"
                Else
                    Result = Result / 1000
                    DimResult = " ms"
                End If
            End If
        ElseIf Result <> 0 Then
            Result = 1000 / Result
            If Result >= 1 Then
                DimResult = " MHz"
            Else
                Result = Result * 1000
                If Result >= 1 Then
                    DimResult = " KHz"
                Else
                    Result = Result * 1000
                    DimResult = " Hz"
                End If
            End If
        Else
            Result = 0
            DimResult = ""
        End If
        Return (Result)
    End Function

    Private Function FormatTimeDim(ByVal Time As Decimal, ByVal DimResult As String) As String
        Dim Result As String = ""
        If Time >= 100 Then
            Result = Format(Time + 0.0005, "0.00") + DimResult
        ElseIf Time >= 10 Then
            Result = Format(Time + 0.000005, "0.000") + DimResult
        ElseIf Time >= 1 Then
            Result = Format(Time + 0.000005, "0.000") + DimResult
        End If
        Return (Result)
    End Function

    Private Sub Form1_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.SizeChanged
        CalculateTime()
        Write_Spectrum()
    End Sub

    Private Sub Form1_Move(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Move
        CalculateTime()
        Write_Spectrum()
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
        Timer1.Stop()
        WriteIniValue(My.Application.Info.DirectoryPath & "\MyScope.ini", "Default", "Port", (SerialPort1.PortName()))
        WriteIniValue(My.Application.Info.DirectoryPath & "\MyScope.ini", "Scope", "Time-div", (Time_div_set))
        WriteIniValue(My.Application.Info.DirectoryPath & "\MyScope.ini", "Scope", "Time-Text", (TextBox_Horizomtal.Text))
        WriteIniValue(My.Application.Info.DirectoryPath & "\MyScope.ini", "Scope", "Triggervalue", (TrackBar_Trigger.Value))
        WriteIniValue(My.Application.Info.DirectoryPath & "\MyScope.ini", "Scope", "Y-Position", (TrackBar_YPos.Value))
        'WriteIniValue(My.Application.Info.DirectoryPath & "\MyScope.ini", "Scope", "Timer-Interval", (Timer1.Interval))
        'If TextBox4.Visible Then
        'WriteIniValue(My.Application.Info.DirectoryPath & "\MyScope.ini", "Measurement-correction", "Uss-corr", (Uss_corr))
        'WriteIniValue(My.Application.Info.DirectoryPath & "\MyScope.ini", "Measurement-correction", "UssGraph-corr", (UssGr_corr))
        'End If
        'WriteIniValue(My.Application.Info.DirectoryPath & "\MyScope.ini", "Measurement-correction", "Y0-Line", (Y0_Line))
    End Sub

End Class